module Data.String.Ubc.Parse.ParserState
( ParserState(..)
, initialState
, pushScope
, popScope
, modifyScope
)
where

import Data.String.Ubc.Parse.Scope (Scope)

data ParserState = ParserState
        { scopes :: [Scope]
        }

initialState :: ParserState
initialState = ParserState []

pushScope :: Scope -> ParserState -> ParserState
pushScope scope oldState@ParserState{scopes = oldScopes} = oldState{scopes = (scope : oldScopes)}

popScope :: ParserState -> (ParserState, Scope)
popScope oldState@ParserState{scopes = (topScope:restScopes)} = (oldState{scopes = restScopes}, topScope)

modifyScope :: (Scope -> Scope) -> ParserState -> ParserState
modifyScope f oldState@ParserState{scopes = (topScope:restScopes)} = oldState{scopes = (f topScope : restScopes)}
